package me.flashyreese.mods.fabricskyboxes_interop.client.config;

import java.util.function.Consumer;
import java.util.function.Supplier;
import net.minecraft.class_2561;
import net.minecraft.class_2588;
import net.minecraft.class_310;
import net.minecraft.class_4185;
import net.minecraft.class_437;
import net.minecraft.class_4587;
import net.minecraft.class_5244;
import net.minecraft.class_5348;

public class FSBInteropConfigScreen extends class_437 {
    private final class_437 parent;
    private final FSBInteropConfig config;

    public FSBInteropConfigScreen(class_437 parent, FSBInteropConfig config) {
        super(new class_2588(getTranslationKey("title")));
        this.parent = parent;
        this.config = config;
    }

    @Override
    protected void method_25426() {
        method_37063(createBooleanOptionButton(this.field_22789 / 2 - 100 - 110, this.field_22790 / 2 - 10 - 12, 200, 20, "interoperability", value -> config.interoperability = value, () -> config.interoperability, () -> class_310.method_1551().method_1521()));
        method_37063(createBooleanOptionButton(this.field_22789 / 2 - 100 + 110, this.field_22790 / 2 - 10 - 12, 200, 20, "prefer_fsb_native", value -> config.preferFSBNative = value, () -> config.preferFSBNative, this::reloadResourcesIfInterop));
        method_37063(createBooleanOptionButton(this.field_22789 / 2 - 100 - 110, this.field_22790 / 2 - 10 + 12, 200, 20, "process_optifine", value -> config.processOptiFine = value, () -> config.processOptiFine, this::reloadResourcesIfInterop));
        method_37063(createBooleanOptionButton(this.field_22789 / 2 - 100 + 110, this.field_22790 / 2 - 10 + 12, 200, 20, "process_mcpatcher", value -> config.processMCPatcher = value, () -> config.processMCPatcher, this::reloadResourcesIfInterop));
        method_37063(createBooleanOptionButton(this.field_22789 / 2 - 100 - 110, this.field_22790 / 2 - 10 + 36, 200, 20, "debug_mode", value -> config.debugMode = value, () -> config.debugMode, () -> {}));

        method_37063(new class_4185(field_22789 / 2 - 100, field_22790 - 40, 200, 20, class_5244.field_24334, button -> method_25419()));
    }

    private void reloadResourcesIfInterop() {
        if (this.config.interoperability) {
            this.field_22787.method_1521();
        }
    }
    
    @Override
    public void method_25394(class_4587 matrices, int mouseX, int mouseY, float delta) {
        method_25420(matrices);
        method_27534(matrices, this.field_22793, this.field_22785, this.field_22789 / 2, 30, 0xFFFFFF);
        super.method_25394(matrices, mouseX, mouseY, delta);
    }

    @Override
    public void method_25419() {
        field_22787.method_1507(parent);
    }

    @Override
    public void method_25432() {
        this.config.writeChanges();
    }

    private static String getTranslationKey(String optionKey) {
        return "options.fsb-interop." + optionKey;
    }

    private static String getTooltipKey(String translationKey) {
        return translationKey + ".tooltip";
    }

    private class_4185.class_5316 createDefaultTooltipSupplier(class_5348 text) {
        return (button, matrices, mouseX, mouseY) -> {
            method_25417(matrices, this.field_22793.method_1728(text, this.field_22789 / 100 * 100 / 2), mouseX, mouseY);
        };
    }

    private class_4185 createBooleanOptionButton(int x, int y, int width, int height, String key, Consumer<Boolean> consumer, Supplier<Boolean> supplier, Runnable onChange) {
        String translationKey = getTranslationKey(key);
        class_2561 text = new class_2588(translationKey);
        class_2561 tooltipText = new class_2588(getTooltipKey(translationKey));
        return new class_4185(x, y, width, height, class_5244.method_30619(text, supplier.get()),
                button -> {
                    boolean newValue = !supplier.get();
                    button.method_25355(class_5244.method_30619(text, newValue));
                    consumer.accept(newValue);
                    onChange.run();
                },
                createDefaultTooltipSupplier(tooltipText)
        );
    }
}
